const path = require("path")
const UglifyJsPlugin = require("uglifyjs-webpack-plugin")
const glob = require("glob")

module.exports = {
  watch: true,
  entry: {
    "bundle.js": glob.sync("build/static/?(js|css)/main.*.?(js|css)").map(f => path.resolve(__dirname, f)),
  },
  output: {
    path: path.resolve(__dirname, 'build'),
    filename: 'index.js',
    libraryTarget: 'commonjs2' // THIS IS THE MOST IMPORTANT LINE! :mindblow: I wasted more than 2 days until realize this was the line most important in all this guide.
  },
  module: {
    rules: [
      {
        test: /\.css$/,
        use: ["style-loader", "css-loader"],
      },
      // All files with a '.ts' or '.tsx' extension will be handled by 'awesome-typescript-loader'.
      { test: /\.tsx?$/, loader: "awesome-typescript-loader" },

      // All output '.js' files will have any sourcemaps re-processed by 'source-map-loader'.
      { enforce: "pre", test: /\.js$/, loader: "source-map-loader" }
    ]
    // loaders: [
    //     {
    //         test: /\.html$/,
    //         loader: 'file-loader?name=[name].[ext]',
    //     },
    //     {
    //         test: /\.jsx?$/,
    //         exclude: /node_modules/,
    //         loader: 'babel-loader',
    //         query: {
    //             presets: ['es2015', 'react']
    //         }
    //     },
    //     ,
    //     {
    //         test: /\.tsx?$/,
    //         exclude: /node_modules/,
    //         loader: 'babel-loader',
    //         query: {
    //             presets: ['es2015', 'react']
    //         }
    //     },
    // ]
  },
  plugins: [new UglifyJsPlugin()],
}